package com.tzld.longarticle.recommend.server;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Lists;
import com.tzld.longarticle.recommend.server.repository.crawler.AccountAvgInfoRepository;
import com.tzld.longarticle.recommend.server.repository.crawler.ArticleDetailInfoRepository;
import com.tzld.longarticle.recommend.server.repository.crawler.ArticleRepository;
import com.tzld.longarticle.recommend.server.repository.entity.crawler.AccountAvgInfo;
import com.tzld.longarticle.recommend.server.repository.entity.crawler.Article;
import com.tzld.longarticle.recommend.server.repository.entity.crawler.ArticleDetailInfo;
import com.tzld.longarticle.recommend.server.repository.mapper.crawler.CrawlerBaseMapper;
import com.tzld.longarticle.recommend.server.service.RecommendService;
import com.tzld.longarticle.recommend.server.service.recall.RecallService;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

@SpringBootTest(classes = Application.class)
public class RecommendTest {

    @Resource
    private RecommendService recommendService;
    @Resource
    private RecallService recallService;
    @Resource
    private ArticleRepository articleRepository;
    @Resource
    private ArticleDetailInfoRepository articleDetailInfoRepository;
    @Resource
    private AccountAvgInfoRepository accountAvgInfoRepository;
    @Resource
    private CrawlerBaseMapper crawlerBaseMapper;

//    @Test
//    void recall() {
//        RecallParam param = new RecallParam();
//        param.setAccountId("20231213123536190184852");
//        param.setPlanId("20240718181730864154902");
//        RecallResult recallResult = recallService.recall(param);
//        System.out.println(JSONObject.toJSONString(recallResult));
//    }
//
//    @Test
//    void exportData() {
//        Set<String> ghIds = new HashSet<>(Arrays.asList("gh_adca24a8f429", "gh_e0eb490115f5", "gh_51e4ad40466d", "gh_95ed5ecf9363"));
//        List<Article> articleList = articleRepository.getByGhIdInAndUpdateTimeGreaterThanAndTypeEquals(ghIds, 1722441600L, "9");
//
//        Map<String, Map<Integer, List<Article>>> map = articleList.stream()
//                .collect(Collectors.groupingBy(Article::getTitle, Collectors.groupingBy(Article::getItemIndex)));
//        Set<String> snList = articleList.stream().map(Article::getWxSn).collect(Collectors.toSet());
//        List<ArticleDetailInfo> articleDetailInfoList = articleDetailInfoRepository.getAllByWxSnIn(new ArrayList<>(snList));
//        Map<String, List<ArticleDetailInfo>> articleDetailInfoMap = articleDetailInfoList.stream()
//                .collect(Collectors.groupingBy(ArticleDetailInfo::getWxSn));
//
//        List<AccountAvgInfo> accountAvgInfoList = accountAvgInfoRepository.getAllByGhIdInAndStatusEquals(ghIds, 1);
//        Map<String, Map<String, AccountAvgInfo>> accountAvgInfoIndexMap = accountAvgInfoList.stream().collect(
//                Collectors.groupingBy(AccountAvgInfo::getGhId, Collectors.toMap(AccountAvgInfo::getPosition, o -> o)));
//        JSONArray jsonArray = new JSONArray();
//        for (Article article : articleList) {
//            List<ArticleDetailInfo> articleDetailInfos = articleDetailInfoMap.get(article.getWxSn());
//            if (CollectionUtils.isEmpty(articleDetailInfos)) {
//                continue;
//            }
//            Date minDate = articleDetailInfos.stream().map(ArticleDetailInfo::getRecallDt).min(Date::compareTo).orElse(new Date());
//            int sumfirstLevel = 0;
//            int sumFission0 = 0;
//            int sumFission1 = 0;
//            int sumFission2 = 0;
//            for (ArticleDetailInfo articleDetailInfo : articleDetailInfos) {
//                if (articleDetailInfo.getRecallDt().equals(minDate)) {
//                    sumfirstLevel += Optional.ofNullable(articleDetailInfo.getFirstLevel()).orElse(0);
//                    sumFission0 += Optional.ofNullable(articleDetailInfo.getFission0()).orElse(0);
//                    sumFission1 += Optional.ofNullable(articleDetailInfo.getFission1()).orElse(0);
//                    sumFission2 += Optional.ofNullable(articleDetailInfo.getFission2()).orElse(0);
//                }
//            }
//            Map<String, AccountAvgInfo> accountAvgInfoMap = accountAvgInfoIndexMap.get(article.getGhId());
//            AccountAvgInfo avgInfo = accountAvgInfoMap.get(article.getItemIndex().toString());
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String date = sdf.format(new Date(article.getUpdateTime() * 1000));
//            JSONObject obj = new JSONObject();
//            obj.put("ghId", article.getGhId());
//            obj.put("accountName", article.getAccountName());
//            obj.put("title", article.getTitle());
//            obj.put("index", article.getItemIndex());
//            obj.put("viewCount", article.getShowViewCount());
//            obj.put("time", date);
//            if (Objects.nonNull(avgInfo)) {
//                obj.put("fans", avgInfo.getFans());
//                obj.put("avgViewCount", avgInfo.getReadAvg());
//                obj.put("viewCountRate", (article.getShowViewCount() * 1.0) / avgInfo.getReadAvg());
//            }
//            obj.put("firstLevel", sumfirstLevel);
//            obj.put("fission0", sumFission0);
//            obj.put("fission1", sumFission1);
//            obj.put("fission2", sumFission2);
//            jsonArray.add(obj);
//        }
//        System.out.println(jsonArray.toJSONString());
//    }
//
//    @Test
//    void ii() throws IOException {
//        String dateStr = "20240911";
//        List<AccountAvgInfo> accountAvgInfoList = accountAvgInfoRepository.getAllByStatusEquals(1);
//        Map<String, String> accountMap = accountAvgInfoList.stream().collect(
//                Collectors.toMap(AccountAvgInfo::getAccountName, AccountAvgInfo::getGhId, (existing, replacement) -> replacement));
//        BufferedReader reader = new BufferedReader(new FileReader("/Users/wangyunpeng/Downloads/账号相关性.json"));
//        StringBuilder sb = new StringBuilder();
//        String line;
//        while ((line = reader.readLine()) != null) {
//            sb.append(line);
//        }
//        String jsonStr = sb.toString();
//        // 使用 ObjectMapper 解析 JSON
//        ObjectMapper objectMapper = new ObjectMapper();
//
//        try {
//            // 将 JSON 转换为 Map<String, Map<String, Double>>
//            Map<String, Map<String, Double>> result = objectMapper.readValue(jsonStr,
//                    new TypeReference<Map<String, Map<String, Double>>>() {
//                    });
//
//            // 输出转换结果
//            System.out.println(result);
//            List<AccountCorrelation> saveList = new ArrayList<>();
//            result.forEach((k, v) -> {
//                String ghId = accountMap.get(k);
//                v.forEach((k1, v1) -> {
//                    String relGhId = accountMap.get(k1);
//                    AccountCorrelation save = new AccountCorrelation();
//                    save.setDateStr(dateStr);
//                    save.setGhId(ghId);
//                    save.setAccountName(k);
//                    save.setRelGhId(relGhId);
//                    save.setRelAccountName(k1);
//                    save.setStatus(1);
//                    save.setCorrelation(v1);
//                    saveList.add(save);
//                });
//            });
//            List<AccountCorrelation> all = new ArrayList<>(saveList);
//            for (AccountCorrelation item : all) {
//                if (!item.getGhId().equals(item.getRelGhId())) {
//                    AccountCorrelation save = new AccountCorrelation();
//                    BeanUtils.copyProperties(item, save);
//                    save.setGhId(item.getRelGhId());
//                    save.setAccountName(item.getRelAccountName());
//                    save.setRelGhId(item.getGhId());
//                    save.setRelAccountName(item.getAccountName());
//                    saveList.add(save);
//                }
//            }
//            crawlerBaseMapper.batchInsertAccountCorrelation(saveList);
//
//
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

    @Test
    public void test() {
        List<String> morning = Lists.newArrayList("gh_d2cc901deca7", "gh_9e559b3b94ca", "gh_e75dbdc73d80", "gh_26a307578776", "gh_4568b5a7e2fe", "gh_5ff48e9fb9ef", "gh_6d9f36e3a7be", "gh_9f8dc5b0c74e", "gh_183d80deffb8", "gh_084a485e859a", "gh_7b4a5f86d68c", "gh_660afe87b6fd", "gh_1686250f15b6", "gh_03d45c260115", "gh_57c9e8babea7", "gh_2e615fa75ffb", "gh_98ec0ffe69b3", "gh_6d3aa9d13402", "gh_7c66e0dbd2cf", "gh_bfea052b5baa", "gh_749271f1ccd5", "gh_e0eb490115f5", "gh_d5f935d0d1f2", "gh_51e4ad40466d", "gh_30816d8adb52", "gh_4c058673c07e", "gh_789a40fe7935", "gh_970460d9ccec", "gh_03d32e83122f", "gh_adca24a8f429", "gh_3e91f0624545", "gh_0e4fd9e88386", "gh_93e00e187787", "gh_95ed5ecf9363", "gh_68e7fdc09fe4", "gh_ac43e43b253b", "gh_be8c29139989", "gh_77f36c109fb1", "gh_744cb16f6e16", "gh_ac43eb24376d", "gh_c91b42649690", "gh_57573f01b2ee", "gh_008ef23062ee", "gh_de9f9ebc976b", "gh_058e41145a0c", "gh_969f5ea5fee1", "gh_e24da99dc899");
        List<String> moon = Lists.newArrayList("gh_a2901d34f75b", "gh_1ee2e1b39ccf", "gh_ee78360d06f5", "gh_192c9cf58b13", "gh_b676b7ad9b74", "gh_3ed305b5817f", "gh_ff487cb5dab3", "gh_89ef4798d3ea", "gh_7e5818b2dd83", "gh_72bace6b3059", "gh_6d205db62f04", "gh_56ca3dae948c", "gh_5ae65db96cb7", "gh_b15de7c99912", "gh_c5cdf60d9ab4", "gh_b6f2c5332c72", "gh_6b7c2a257263", "gh_9eef14ad6c16", "gh_1d887d61088c", "gh_f902cea89e48", "gh_dd4c857bbb36", "gh_0c89e11f8bf3", "gh_bff0bcb0694a", "gh_d4dffc34ac39", "gh_1b27dd1beeca", "gh_bfe5b705324a", "gh_080bb43aa0dc", "gh_6cfd1132df94", "gh_29074b51f2b7", "gh_c69776baf2cd", "gh_f25b5fb01977", "gh_9877c8541764", "gh_d49df5e974ca", "gh_7f5075624a50");
        String dateStr = "2024-09-12";
        List<Article> articleList = articleRepository.getByUpdateTimeGreaterThanAndTypeEquals(1726070400L, "9");
        articleList = articleList.stream().filter(o -> o.getItemIndex() == 1).collect(Collectors.toList());
        Map<String, List<Article>> map = articleList.stream().collect(Collectors.groupingBy(Article::getTitle));
        List<AccountAvgInfo> accountAvgInfoList = accountAvgInfoRepository.getAllByUpdateTime(dateStr);
        accountAvgInfoList = accountAvgInfoList.stream().filter(o -> o.getPosition().equals("1")).collect(Collectors.toList());
        Map<String, AccountAvgInfo> accountAvgInfoMap = accountAvgInfoList.stream().collect(Collectors.toMap(AccountAvgInfo::getGhId, o -> o));
        List<String> wxSnList = articleList.stream().map(Article::getWxSn).collect(Collectors.toList());
        List<ArticleDetailInfo> articleDetailInfoList = articleDetailInfoRepository.getAllByWxSnIn(wxSnList);
        Map<String, List<ArticleDetailInfo>> articleDetailInfoMap = articleDetailInfoList.stream()
                .collect(Collectors.groupingBy(ArticleDetailInfo::getWxSn));
        JSONArray result = new JSONArray();
        int sumFission0Morning = 0;
        int sumFission0Moon = 0;
        double readAvgMorning = 0.0;
        double readAvgMoon = 0.0;
        for (Article article : articleList) {
            List<ArticleDetailInfo> articleDetailInfos = articleDetailInfoMap.get(article.getWxSn());
            if (CollectionUtil.isEmpty(articleDetailInfos)) {
                continue;
            }
            Date minDate = articleDetailInfos.stream().map(ArticleDetailInfo::getRecallDt).min(Date::compareTo).orElse(new Date());
            AccountAvgInfo accountAvgInfo = accountAvgInfoMap.get(article.getGhId());
            int sumFission0 = 0;
            for (ArticleDetailInfo articleDetailInfo : articleDetailInfos) {
                if (articleDetailInfo.getRecallDt().equals(minDate) && Objects.nonNull(articleDetailInfo.getFission0())) {
                    if (morning.contains(article.getGhId())) {
                        sumFission0Morning += articleDetailInfo.getFission0();
                    }
                    if (moon.contains(article.getGhId())) {
                        sumFission0Moon += articleDetailInfo.getFission0();
                    }
                }
            }
            if (Objects.nonNull(accountAvgInfo)) {
                if (morning.contains(article.getGhId())) {
                    readAvgMorning += accountAvgInfo.getReadAvg();
                }
                if (moon.contains(article.getGhId())) {
                    readAvgMoon += accountAvgInfo.getReadAvg();
                }
            }
        }
        JSONObject jsonObjectMorning = new JSONObject();
        jsonObjectMorning.put("时间", "早上");
        jsonObjectMorning.put("sumFission0", sumFission0Morning);
        jsonObjectMorning.put("readAvg", readAvgMorning);
        jsonObjectMorning.put("rate", sumFission0Morning/ readAvgMorning);
        result.add(jsonObjectMorning);
        JSONObject jsonObjectMoon = new JSONObject();
        jsonObjectMoon.put("时间", "中午");
        jsonObjectMoon.put("sumFission0", sumFission0Moon);
        jsonObjectMoon.put("readAvg", readAvgMoon);
        jsonObjectMoon.put("rate", sumFission0Moon/ readAvgMoon);
        result.add(jsonObjectMoon);
        System.out.println(JSONObject.toJSONString(result));
    }

}
